; PureCrypt Test v1.0a

OpenConsole()

; Hash functions

; SHA1Hash (20 byte hash)

; Accessing one byte:
;*hash = SHA1Hash("abc", 3)
; if (PeekB(*hash) < 0)
;   Debug 256+PeekB(*hash)
; else
;   Debug PeekB(*hash)
; Endif
; Accessing all 20 bytes:
Structure Sha1Struct
  StructureUnion
    ByteArray.b[20]
    WordArray.w[10]
    LongArray.l[5]
  EndStructureUnion
EndStructure

; Need to add a check for null somehow - not sure PB supports this
*SHA1hash.Sha1Struct = SHA1Hash("abc", 3)

; We have to convert the data given because our test data is in the
; form of unsigned char, whereas the data itself is in the form of
; signed char.
For i = 0 To 19
  SHA1text.s + RSet(Hex(*SHA1hash\ByteArray[i] & $ff), 2, "0")
Next i
PrintN("SHA1 Hash: "+SHA1text)
If (CompareMemory("A9993E364706816ABA3E25717850C26C9CD0D89D", SHA1text, 40) = 1)
  PrintN(" Passed")
Else
  PrintN(" Failed")
EndIf
PrintN("")

; SHA256Hash (32 byte hash)

; Accessing one byte:
;*hash = SHA256Hash("abc", 3)
; if (PeekB(*hash) < 0)
;   Debug 256+PeekB(*hash)
; else
;   Debug PeekB(*hash)
; Endif
; Accessing all 32 bytes:
Structure Sha256Struct
  StructureUnion
    ByteArray.b[32]
    WordArray.w[16]
    LongArray.l[8]
  EndStructureUnion
EndStructure

; Need to add a check for null somehow - not sure PB supports this
*SHA256hash.Sha256Struct = SHA256Hash("abc", 3)

; We have to convert the data given because our test data is in the
; form of unsigned char, whereas the data itself is in the form of
; signed char.
For i = 0 To 31
  SHA256text.s + RSet(Hex(*SHA256hash\ByteArray[i] & $ff), 2, "0")
Next i
PrintN("SHA256 Hash: "+SHA256text)
If (CompareMemory("BA7816BF8F01CFEA414140DE5DAE2223B00361A396177A9CB410FF61F20015AD", SHA256text, 64) = 1)
  PrintN(" Passed")
Else
  PrintN(" Failed")
EndIf
PrintN("")

; SHA512Hash (64 byte hash)

; Accessing one byte:
;*hash = SHA512Hash("abc", 3)
; if (PeekB(*hash) < 0)
;   Debug 256+PeekB(*hash)
; else
;   Debug PeekB(*hash)
; Endif
; Accessing all 64 bytes:
Structure Sha512Struct
  StructureUnion
    ByteArray.b[64]
    WordArray.w[32]
    LongArray.l[16]
  EndStructureUnion
EndStructure

; Need to add a check for null somehow - not sure PB supports this
*SHA512hash.Sha512Struct = SHA512Hash("abc", 3)

; We have to convert the data given because our test data is in the
; form of unsigned char, whereas the data itself is in the form of
; signed char.
For i = 0 To 63
  SHA512text.s + RSet(Hex(*SHA512hash\ByteArray[i] & $ff), 2, "0")
Next i
PrintN("SHA512 Hash: "+SHA512text)
If (CompareMemory("DDAF35A193617ABACC417349AE20413112E6FA4E89A97EA20A9EEEE64B55D39A2192992A274FC1A836BA3C23A3FEEBBD454D4423643CE80E2A9AC94FA54CA49F", SHA512text, 128) = 1)
  PrintN(" Passed")
Else
  PrintN(" Failed")
EndIf
PrintN("")

; Cipher functions

; Blowfish cipher
Structure BFStruct
  StructureUnion
    ByteArray.b[8]
    WordArray.w[4]
    LongArray.l[2]
  EndStructureUnion
EndStructure

; Need to add a check for null somehow - not sure PB supports this
*BFencode.BFStruct = BlowfishEncode("12345678", 8, "abcdefgh", 0)

; We have to convert the data given because our test data is in the
; form of unsigned char, whereas the data itself is in the form of
; signed char.
For i = 0 To 7
  BFtext.s + Chr(*BFencode\ByteArray[i])
Next i
PrintN("Blowfish Encrypted: "+BFtext)

*BFdecode.BFStruct = BlowfishDecode("12345678", 8, *BFencode, 0)
For i = 0 To 7
  BFDtext.s + Chr(*BFdecode\ByteArray[i])
Next i
PrintN("Blowfish Decrypted: "+BFDtext)
If (CompareMemory("abcdefgh", BFDtext, 8) = 1)
  PrintN(" Passed")
Else
  PrintN(" Failed")
EndIf
PrintN("")

Print("<Press a key to continue>")
Repeat
  key$ = Inkey()
Until key$ <> ""

CloseConsole()
; ExecutableFormat=Windows
; CursorPosition=34
; FirstLine=10
; Executable=D:\Work\Projects\Programming\PureCrypt\Examples\PureCrypt Test.exe
; DisableDebugger
; EOF