///////////////////////////////////////////////////////////////////////////////
// PureCrypt v1.0a                                                           //
///////////////////////////////////////////////////////////////////////////////
// Contains library debugger functions and test routine.                     //
///////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <windows.h>
#include "System.h"
#include "DebuggerModule.h"

// Disable the following line to test your library ////////////////////////////
#define PURELIBRARY

// PureBASIC variables
#ifdef PURELIBRARY
extern HINSTANCE PB_Instance;
extern char *PB_StringBase;
extern int *PB_MemoryBase;
#else
HINSTANCE PB_Instance;
char *PB_StringBase;
extern int *PB_MemoryBase;
#endif

// Debugger function interface ////////////////////////////////////////////////

// --- All command debug equivalent (name + _DEBUG)
// No more '_stdcall' as the arguments aren't unstacked..

extern void PB_SHA1Hash_DEBUG(uchar8 *buffer, ulong32 length)
{
  if (!buffer)
    SendDebuggerError("No input buffer !");

  if (length == 0)
    SendDebuggerError("0 length input !");
}

extern void PB_SHA256Hash_DEBUG(uchar8 *buffer, ulong32 length)
{
  if (!buffer)
    SendDebuggerError("No input buffer !");

  if (length == 0)
    SendDebuggerError("0 length input !");
}

extern void PB_SHA512Hash_DEBUG(uchar8 *buffer, ulong32 length)
{
  if (!buffer)
    SendDebuggerError("No input buffer !");

  if (length == 0)
    SendDebuggerError("0 length input !");
}

extern void PB_BlowfishEncode_DEBUG(uchar8 *password, ulong32 length, uchar8 *buffer, int rounds)
{
}

extern void PB_BlowfishDecode_DEBUG(uchar8 *password, ulong32 length, uchar8 *buffer, int rounds)
{
}

// Test library ///////////////////////////////////////////////////////////////

#ifndef PURELIBRARY

// Not done yet
int main()
{
  PB_MessageBox(0, "Titre", "Text", 0);
  return 0;
}

#endif
