///////////////////////////////////////////////////////////////////////////////
// PureCrypt v1.0a                                                           //
///////////////////////////////////////////////////////////////////////////////
// Contains library defines, macros, structures etc.                         //
///////////////////////////////////////////////////////////////////////////////

// SHA-1 //////////////////////////////////////////////////////////////////////

typedef struct sha1 {
  ulong64 length;
  ulong32 state[5];
  ulong32 curlen;
  uchar8 buf[64];
} SHA1;

int sha1_compress(SHA1 *md, uchar8 *buf);
int sha1_init(SHA1 *md);
int sha1_done(SHA1 *md, uchar8 *out);
int sha1_process(SHA1 *md, uchar8 *in, ulong32 inlen);

// Size of hash
#define SHA1Length 20
