///////////////////////////////////////////////////////////////////////////////
// PureCrypt v1.0a                                                           //
///////////////////////////////////////////////////////////////////////////////
// Contains library defines, macros, structures etc.                         //
///////////////////////////////////////////////////////////////////////////////

// SHA-256 ////////////////////////////////////////////////////////////////////

typedef struct sha256 {
    ulong64 length;
    ulong32 state[8];
    ulong32 curlen;
    uchar8 buf[64];
} SHA256;

int sha256_compress(SHA256 *md, uchar8 *buf);
int sha256_init(SHA256 *md);
int sha256_done(SHA256 *md, uchar8 *out);
int sha256_process(SHA256 *md, uchar8 *in, ulong32 inlen);
